package net.mysoftworks.modulecompiler.model.values;


import net.mysoftworks.modulecompiler.model.ValueLob;

import javax.persistence.*;
import javax.xml.bind.annotation.XmlAttribute;
import javax.xml.bind.annotation.XmlTransient;
import java.math.BigDecimal;
import java.util.Calendar;

/**
 * MetaGruppo generated by hbm2java
 */
@Entity
@Table(name="MC_V_RAW_VALUE")
//@NamedQueries({@NamedQuery(name = Value.FIND_BY_PRATICA,
//query="SELECT new map(v.id,v) FROM Value v where v.idPratica = :" + Value.FIND_BY_PRATICA_PARAM)})
public class RawValue implements java.io.Serializable {
	//	public static final String FIND_BY_PRATICA="net.mysoftworks.modulecompiler.model.values.Value.FIND_BY_PRATICA";
//	public static final String FIND_BY_PRATICA_PARAM="idPratica";
	private static final long serialVersionUID = 1L;

	@Id
	@GeneratedValue(strategy = GenerationType.IDENTITY)
	private Long id;

	@OneToOne(fetch = FetchType.LAZY,cascade = CascadeType.ALL)
	@JoinColumn(name = "ID_LOB")
	private ValueLob lobValue;

	@Column(name = "ID_LOB",insertable = false,updatable = false)
	private Long idLob;

	public Long getIdLob() {
		return idLob;
	}

	@ManyToOne(fetch = FetchType.LAZY)
	@JoinColumn(name = "ID_VALUE", referencedColumnName = "ID")
	private Value value;

	@XmlTransient
	public Value getValue() {
		return value;
	}

	public void setValue(Value value) {
		this.value = value;
	}

	@PreUpdate
	public void preUpdate() {
		value.preUpdate();
	}

	@PrePersist
	public void prePersist() {
		value.preUpdate();
	}


//	@Column(name = "LONG_VALUE")
//	private Long longValue;

	@Column(name = "STRING_VALUE")
	private String stringValue;

	@Column(name = "BOOLEAN_VALUE")
	private Boolean booleanValue;

	@Column(name = "DATE_VALUE")
	private Calendar dateValue;


//	@Column(name = "DOUBLE_VALUE")
//	private Double doubleValue;
//
//	@Column(name = "FLOAT_VALUE")
//	private Float floatValue;
//
//	@Column(name = "INT_VALUE")
//	private Integer intValue;

	@Column(name = "BIG_D_VALUE")
	private BigDecimal bigDValue;

//	@Column(name = "SHORT_VALUE")
//	private Short shortValue;

//	@Column(name = "BYTE_VALUE")
//	private Byte byteValue;

//	@Column(name = "CHAR_VALUE")
//	private Character charValue;

	@XmlAttribute
	public Long getId() {
		return id;
	}

	public void setId(Long id) {
		this.id = id;
	}

	@XmlTransient
	public ValueLob getLobValue() {
		return lobValue;
	}

	public void setLobValue(ValueLob lobValue) {
		this.lobValue = lobValue;
	}

	public Long getLongValue() {

		return bigDValue!=null ? bigDValue.longValue() : null;
//		return longValue;
	}

	public void setLongValue(Long longValue) {
		bigDValue = longValue!=null ? new BigDecimal(longValue):null;
//		this.longValue = longValue;
	}

	public String getStringValue() {
		return stringValue;
	}

	public void setStringValue(String stringValue) {
		this.stringValue = stringValue;
	}

	public Boolean getBooleanValue() {
		return booleanValue;
	}

	public void setBooleanValue(Boolean booleanValue) {
		this.booleanValue = booleanValue;
	}

	public Calendar getDateValue() {
		return dateValue;
	}

	public void setDateValue(Calendar dateValue) {
		this.dateValue = dateValue;
	}

	public Double getDoubleValue() {
		return bigDValue!=null ? bigDValue.doubleValue() : null;
//		return doubleValue;
	}

	public void setDoubleValue(Double doubleValue) {
		bigDValue = doubleValue!=null ? new BigDecimal(doubleValue):null;
//		this.doubleValue = doubleValue;
	}

	public Float getFloatValue() {
		return bigDValue!=null ? bigDValue.floatValue() : null;
//		return floatValue;
	}

	public void setFloatValue(Float floatValue) {
		bigDValue = floatValue !=null ? new BigDecimal(floatValue):null;
//		this.floatValue = floatValue;
	}

	public Integer getIntValue() {

		return bigDValue!=null ? bigDValue.intValue() : null;
//		return intValue;
	}

	public void setIntValue(Integer intValue) {
		bigDValue = intValue!=null ? new BigDecimal(intValue) : null;
//		this.intValue = intValue;
	}

	public BigDecimal getBigDValue() {
		return bigDValue;
	}

	public void setBigDValue(BigDecimal bigDValue) {
		this.bigDValue = bigDValue;
	}

	public Short getShortValue() {

		return bigDValue!=null ? bigDValue.shortValue() : null;
//		return shortValue;
	}

	public void setShortValue(Short shortValue) {
		bigDValue = shortValue!=null ? new BigDecimal(shortValue) : null;
//		this.shortValue = shortValue;
	}

	public Byte getByteValue() {
		return bigDValue!=null ? bigDValue.byteValue() : null;
//		return byteValue;
	}

	public void setByteValue(Byte byteValue) {
		bigDValue = byteValue!=null ? new BigDecimal(byteValue) : null;
//		this.byteValue = byteValue;
	}

//	public Character getCharValue() {
//		return charValue;
//	}
//
//	public void setCharValue(Character charValue) {
//		this.charValue = charValue;
//	}

	//	public Object getPrintValue() {
//		MetaField field = value.getField();
//		if (String.class.getName().equals(field.getJavaType())) return getStringValue();
//		if (Integer.class.getName().equals(field.getJavaType()) || Long.class.getName().equals(field.getJavaType())) return getLongValue();
//		if (Timestamp.class.getName().equals(field.getJavaType())) return getDateTimeValue();
//		if (Time.class.getName().equals(field.getJavaType())) return getTimeValue();
//		if (Boolean.class.getName().equals(field.getJavaType())) return getBooleanValue();
//		return null;
//	}


	@Override
	public String toString() {
		final StringBuilder sb = new StringBuilder("RawValue{");
		sb.append("id=").append(id);
		sb.append(", idLob=").append(idLob);
		sb.append(", value=").append(value);
		sb.append(", stringValue='").append(stringValue).append('\'');
		sb.append(", booleanValue=").append(booleanValue);
		sb.append(", dateValue=").append(dateValue);
		sb.append(", bigDValue=").append(bigDValue);
		sb.append('}');
		return sb.toString();
	}
}

